import java.util.*;

// Watch Your Step checker

public class JohnChecker
{

    public static final int MINN = 1;
	public static final int MAXN = 2500;
    public static final int MINV = 0;
	public static final int MAXV = 1;

    public static boolean[][] matrix = new boolean[MAXN][MAXN];

    public static void printError(int line, String msg)
	{
		System.out.println("ERROR Line " + line + ": " + msg);
		System.exit(-1);
	}

    public static void checkIntBounds(int x, int min, int max, String name, int nLines)
    {
        if (x < min || x > max)
            printError(nLines, "invalid " + name + " value: " + x);
    }

    public static boolean checkForPath(int n)
    {
        for(int k=0; k<n; k++)
            for(int i=0; i<n; i++)
                for(int j=0; j<n; j++)
                    if (matrix[i][k] && matrix[k][j])
                        matrix[i][j] = true;            // modified Floyd's
        for(int i=0; i<n; i++) {                // now check if there is one vertex that can reach all others
            boolean found = true;
            for(int j=0; j<n; j++) {
                if (j==i)
                    continue;
                if (!matrix[i][j]) {
                    found = false;
                    break;
                }
            }
            if (found)
                return true;
        }
        return false;
    }

    public static void main(String [] args)
	{
		Scanner in = new Scanner(System.in);
		String line;
		int nLines=0;

        line = in.nextLine();
        nLines++;
        StringTokenizer st = new StringTokenizer(line);
        if (st.countTokens() != 1)
            printError(nLines, "number of values on line incorrect");
		int n = Integer.parseInt(st.nextToken());
		checkIntBounds(n, MINN, MAXN, "n", nLines);
		for(int i=0; i<n; i++) {
            line = in.nextLine();
            st = new StringTokenizer(line);
            if (st.countTokens() != n)
                printError(nLines, "incorrect number of value on line");
            for(int j=0; j<n; j++) {
                int value = Integer.parseInt(st.nextToken());
                checkIntBounds(value, MINV, MAXV, "value", nLines);
                if (j == i && value == 1)
                    printError(nLines, "path from vertex " + (i+1) + " to itself");
                matrix[i][j] = (value == 1);
            }
 		}
 		if (!checkForPath(n))
            printError(nLines, "no full path found");
		if (in.hasNextLine())
			printError(nLines, "incorrect number of lines");
        System.exit(42);
	}
}
