import java.util.Scanner;

public class wwys_faster_bobk {

  private boolean[][]
    adj,
    adjT,
    adjSCC;

  private int
    nV,
    nSCC,
    curSCC,
    m;

  private int[]
    vCounts,
    sccNum,
    order,
    color;

  private void visit1(int v) {

    color[v] = 1;

    for (int i=0;i<nV;i++)
      if (adj[v][i] && color[i] == 0)
        visit1(i);

    m--;
    order[m] = v;

    color[v] = 2;
  }

  private void visit2(int v) {

    color[v] = 1;

    vCounts[nSCC]++;
    sccNum[v] = nSCC;

    for (int i=0;i<nV;i++)
      if (adjT[v][i] && color[i] == 0)
        visit2(i);

    color[v] = 2;
  }

  private void visit3(int v) {

    color[v] = 1;

    for (int i=0;i<nSCC;i++)
      if (adjSCC[v][i] && color[i] == 0)
        visit3(i);

    m--;
    order[m] = v;

    color[v] = 2;
  }

  private void sweep1() {

    for (int i=0;i<nV;i++)
      color[i] = 0;

    m = nV;

    for (int i=0;i<nV;i++)
      if (color[i] == 0)
        visit1(i);
  }

  private void sweep2() {

    for (int i=0;i<nV;i++)
      color[i] = 0;

    nSCC = 0;

    for (int i=0;i<nV;i++)
      if (color[order[i]] == 0) {
        visit2(order[i]);
        nSCC++;
      }
  }

  private void sweep3() {

    for (int i=0;i<nSCC;i++)
      color[i] = 0;

    m = nSCC;

    for (int i=0;i<nSCC;i++)
      if (color[i] == 0)
        visit3(i);
  }

  private void dumpData() {

    for (int i=0;i<nV;i++) {
      for (int j=0;j<nV;j++)
        System.out.print(adj[i][j]?1:0);
      System.out.println();
    }
    System.out.println();

    for (int i=0;i<nV;i++) {
      for (int j=0;j<nV;j++)
        System.out.print(adjT[i][j]?1:0);
      System.out.println();
    }
    System.out.println();

    for (int i=0;i<nSCC;i++) {
      for (int j=0;j<nSCC;j++)
        System.out.print(adjSCC[i][j]?1:0);
      System.out.println();
    }
    System.out.println();

    System.out.println("SCCs: " + nSCC);
    for (int i=0;i<nV;i++)
      System.out.print(" " + sccNum[i]);
    System.out.println('\n');

    System.out.print("Order:");
    for (int i=0;i<nV;i++)
      System.out.print(" " + order[i]);
    System.out.println('\n');
  }

  private void solve() {
    Scanner
      in = new Scanner(System.in);
    int
      e;

    nV = in.nextInt();

    adj = new boolean[nV][nV];
    adjT = new boolean[nV][nV];
    adjSCC = new boolean[nV][nV];

    vCounts = new int[nV];
    sccNum = new int[nV];
    order = new int[nV];
    color = new int[nV];

    for (int i=0;i<nV;i++)
      for (int j=0;j<nV;j++) {
        e = in.nextInt();
        adj[i][j] = (e == 1);
        adjT[j][i] = (e == 1);
      }

    sweep1();

    sweep2();

    for (int i=0;i<nV;i++)
      for (int j=0;j<nV;j++)
        if (adj[i][j])
          adjSCC[sccNum[i]][sccNum[j]] = true;

    for (int i=0;i<nSCC;i++)
      adjSCC[i][i] = false;

    sweep3();

//dumpData();

    e = 0;

    for (int i=nSCC-1;i>=0;i--) {
      e += vCounts[order[i]] * vCounts[order[i]];
      for (int j=0;j<nSCC;j++)
        if (adjSCC[order[i]][j])
          e += vCounts[order[i]] * vCounts[j];
      for (int j=0;j<nSCC;j++)
        if (adjSCC[order[i]][j]) {
          vCounts[order[i]] += vCounts[j];
          vCounts[j] = 0;
        }
    }

    e -= nV;

    for (int i=0;i<nV;i++)
      for (int j=0;j<nV;j++)
        if (adj[i][j])
          e--;

    System.out.println(e);
  }

  public static void main(String[] args) {
    wwys_faster_bobk
      solver = new wwys_faster_bobk();

    solver.solve();
  }
}
