#include <iostream>
#include <stack>
#include <bits/stdc++.h>
using namespace std;

const int MAXV = 2500;

class edge
{
public:
    int dest;
    edge *next;

    edge(int d, edge* n=0) : dest(d), next(n)
    {}
};

struct vertex
{
    edge *list;
    bool visited;
} graph[MAXV], inverseGraph[MAXV];

stack<int> dfsStack;
int districtSizes[MAXV];

void dfs(int v)
{
    graph[v].visited = true;
    for(edge* e = graph[v].list; e != 0; e = e->next) {
        int w = e->dest;
        if (!graph[w].visited)
            dfs(w);
    }
    dfsStack.push(v);
}

int findSize(int v)
{
    inverseGraph[v].visited = true;
    int size = 1;
    for(edge* e = inverseGraph[v].list; e != 0; e = e->next) {
        int w = e->dest;
        if (!inverseGraph[w].visited)
            size += findSize(w);
    }
    return size;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, nEdges = 0;
    cin >> n;
    for(int i=0; i<n; i++) {
        graph[i].list = 0;
        graph[i].visited = false;
        inverseGraph[i].list = 0;
        inverseGraph[i].visited = false;
    }
    for(int i=0; i<n; i++) {
        for(int j=0; j<n; j++) {
            int val;
            cin >> val;
            if (val == 1) {
                graph[i].list = new edge(j, graph[i].list);
                inverseGraph[j].list = new edge(i, inverseGraph[j].list);
                nEdges++;
            }
        }
    }
    for(int i=0; i<n; i++)
        if (!graph[i].visited)
            dfs(i);

    int k=0;
    for(int i=0; i<n; i++) {
        int v = dfsStack.top();
        dfsStack.pop();
        if (!inverseGraph[v].visited) {
            districtSizes[k++] = findSize(v);
//            cout << districtSizes[k-1] << endl;
        }
    }
//    cout << "num districts = " << k << endl;
    int numSidewalks = 0;
    for(int i=0; i<k; i++) {
        int size = districtSizes[i];
        numSidewalks += size*(size-1);              // add sidewalks within district i
        for(int j=i+1; j<k; j++)
            numSidewalks += size*districtSizes[j];  // add sidewalks between district i and district j
    }
    cout << numSidewalks - nEdges << endl;

}
